# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _without_gcj_support 1

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/common/1.2.1.GA-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

Name:           jboss-common    
Version:        1.2.1
Release:        0jpp.ep1.2%{?dist}.1
Summary:        Common Utilities for JBoss Projects     
License:        LGPL
Group:          Development/Libraries/Java
URL:            http://labs.jboss.com

# svn export http://anonsvn.jboss.org/repos/common/common-old/tags/JBossCommon_1_2_1_GA/
# tar czf JBossCommon_1_2_1_GA.tar.gz JBossCommon_1_2_1_GA
Source0:        JBossCommon_1_2_1_GA.tar.gz

# Files used for clean-binary-files and create-jar-links
Source1:        jboss-common-exclusion
Source2:        jboss-common-jar-map
Source3:        jboss-common-thirdparty-instructions
Source4:        jboss-common-thirdparty-jar-map

Source5:        jboss-common-libraries.ent

# A modified create-jar-links that preserves the original
# name of the jar.
Source6:        modified-create-jar-links

# Used for repolib
Source7:        jboss-common-component-info.xml

Patch0:         jboss-common-build-compile.patch

%if ! %{gcj_support}
BuildArch: noarch
%endif

BuildRequires: java
BuildRequires: java-devel
BuildRequires: jpackage-utils
BuildRequires: ant
BuildRequires: ant-javamail
BuildRequires: ant-junit
BuildRequires: ant-nodeps
BuildRequires: ant-trax
BuildRequires: bsf
#Not being built from source in el4ep1 yet
#BuildRequires: jboss4-buildmagic-tasks
#BuildRequires: jbossbuild
BuildRequires: junit
BuildRequires: xml-commons-resolver
BuildRequires: xerces-j2
BuildRequires: xml-commons-apis
BuildRequires: concurrent
BuildRequires: dtdparser
BuildRequires: jakarta-commons-httpclient
BuildRequires: ws-jaxme
BuildRequires: log4j
BuildRequires: snmptrapappender
BuildRequires: jakarta-slide-webdavclient
%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
Common Utilities for JBoss Projects

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q -n JBossCommon_1_2_1_GA
%patch0

#tools/lib
pushd tools/lib
# remove not needed jars
rm -f ant-xslp.jar
rm -f jdtCompilerAdapter.jar
rm -f org.eclipse.jdt.core_3.1.0.jar
rm -f xalan.jar
rm -f pretty.jar
# clean files and create symlinks
clean-binary-files -e %{SOURCE1} -l > instructions
clean-binary-files -e %{SOURCE1} -n
sh %{SOURCE6} -d %{SOURCE2} -f instructions
popd


# Thirdparty 

# How to generate the instruction file
#
# 1) take the source tar and unzip
# 2) 'cd build; ant -f build-thirdparty.xml'
# 3) 'cd thirdparty'
# 4) 'clean-binary-files -e jboss-common-exclusion -l > instructions'
# 5) create dep-map file

mkdir -p thirdparty
pushd thirdparty
        cp %{SOURCE5} libraries.ent
        # creates the proper links for the binaries
        sh %{SOURCE6} -d %{SOURCE4} -f %{SOURCE3}
popd 


tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE7}

%build
ant

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jboss-common
install -m 644 output/lib/* $RPM_BUILD_ROOT%{_javadir}/jboss-common

(cd $RPM_BUILD_ROOT%{_javadir}/jboss-common && for jar in *; do mv ${jar} ${jar/.jar/-%{version}.jar};done)
(cd $RPM_BUILD_ROOT%{_javadir}/jboss-common && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif


%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE7} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-common/namespace.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-common/jboss-common.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-common/jboss-common-client.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-common/jboss-common-sources.jar $RPM_BUILD_ROOT%{repodirlib}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then 
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-, root, root, -)
%{_javadir}/jboss-common

%if %{gcj_support}
%attr(-, root, root, -) %{_libdir}/gcj/jboss-common/*.jar.*
%endif


%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Mon Nov 19 2007 Fernando Nasser <fnasser@redhat.com> - 1.2.1.GA-0jpp.ep1.2.1
- Explicitly define _without_gcj_support

* Mon Nov 19 2007 Fernando Nasser <fnasser@redhat.com> - 1.2.1.GA-0jpp.ep1.2
- Rebuild with JDK 1.4

* Mon Nov 19 2007 Fernando Nasser <fnasser@redhat.com> - 1.2.1.GA-0jpp.ep1.1
- Upgrade

* Thu Aug 02 2007 Fernando Nasser <fnasser@redhat.com> - 1.2.0GA-0jpp.ep1.2.2
- Rebuild

* Fri Jul 27 2007 Fernando Nasser <fnasser@redhat.com> - 1.2.0GA-0jpp.ep1.2.1
- Rebuild with JDK 1.4

* Fri Mar 30 2007 Matt Wringe <mwringe@redhat.com> - 1.2.0GA-0jpp.ep1.2
- Fix version in repodir

* Fri Mar 30 2007 Fernando Nasser <fnasser@redhat.com> - 1.2.0.GA-0jpp.ep1.1
- Upgrade

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> - 1.0.4.GA-0jpp.ep1.1
- New repolib location

* Fri Feb 23 2007 Matt Wringe <mwringe@redhat.com> - 1.0.4.GA-0jpp.2
- Add missing build requires
- Add repolib support
- General spec file clean up

* Fri Feb 23 2007 Permaine Cheugn <pcheung at redhat.com> - 1.0.4.GA-0jpp.1
- Upgrade to 1.0.4 GA

* Thu Nov 2 2006 Matt Wringe <mwringe at redhat.com> - 1.0.0.GA-0jpp.1
- Initial rpm build
